#include "expat_module.h"

static int read_external_dtd;

/*
  These are the external interfaces
*/
char PyParse_doc[] = "\
parse(isrc readExtDtd) -> Document";

PyObject *PyParse(PyObject *self, PyObject *args) {
  PyObject *_argc0, *result;
  int readDtd;

  if(!PyArg_ParseTuple(args, "Oi:parse", &_argc0, &readDtd))
    return NULL;
#ifdef DEBUG_PARSER
  fprintf(stderr, "Start parsing.\n");
#endif

  result = beginParse(_argc0, readDtd);

#ifdef DEBUG_PARSER
  fprintf(stderr,"Finished parsing\n");
#endif

  return result;
}

char NonvalParse_doc[] = "\
nonvalParse(isrc[, readExtDtd]) -> Document";

PyObject *Domlette_NonvalParse(PyObject *self, PyObject *args, PyObject *kw)
{
  PyObject *isrc, *readExtDtd = NULL;
  static char *kwlist[] = {"isrc", "readExtDtd", NULL};
  int readDtd = read_external_dtd;
  PyObject *result;

  if (!PyArg_ParseTupleAndKeywords(args, kw, "O|O:nonvalParse", kwlist, 
                                   &isrc, &readExtDtd))
    return NULL;

  if (readExtDtd) {
    readDtd = PyObject_IsTrue(readExtDtd);
    if (readDtd == -1) return NULL;
  }

#ifdef DEBUG_PARSER
  fprintf(stderr, "Start parsing.\n");
#endif

  result = beginParse(isrc, readDtd);

#ifdef DEBUG_PARSER
  fprintf(stderr,"Finished parsing\n");
#endif

  return result;
}


int DomletteReader_Init(void)
{
  PyObject *module;
  PyObject *constant;

  module = PyImport_ImportModule("Ft.Xml");
  if (module == NULL) return -1;

  constant = PyObject_GetAttrString(module, "READ_EXTERNAL_DTD");
  if (constant == NULL) return -1;

  read_external_dtd = PyObject_IsTrue(constant);
  if (read_external_dtd == -1) return -1;

  return 0;
}

void DomletteReader_Fini(void)
{
  /* no cleanup to perform */
}
